#!/usr/bin/perl

###############################################################################
#                                                                             #
#               Dimke's Email-Form                                            #
#                                                                             #
#               Copyright (C) 2004 Dipl.-Ing. Markus Robert Keler            #
#               Bad Schussenried, Germany                                     #
#               All rights reserved.                                          #
#                                                                             #
#               For latest updates see http://developer.dipl-ing-kessler.de   #
#                                                                             #
###############################################################################
#                                                                             #
#               Purpose:                                                      #
#                                                                             #
#               Send email based on the data passed to this script            #
#               by an html email form without the recipient seeing            #
#               your real email address.                                      #
#               Also the sender can decide to get a copy of what s/he         #
#               had submitted in the html form                                #
#                                                                             #
###############################################################################

### Set your variables here and don't modify other parts of this script #######

$recipient      = 'Your Name <your email>';
$background     = 'http://your.domain/path/picture';
$mailprog       = '/usr/sbin/sendmail';

###############################################################################

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   $FORM{$name} = $value;
}


if ($FORM{'Kunde_Name'} eq '' or $FORM{'Kunde_mail'} eq '' or $FORM{'Betreff'} eq '' or $FORM{'Nachricht'} eq ''){
   ### Error message: One or more fields of the form are not filled out ==> Please go back

   print "Content-Type: text/html\n\n";
   print "<html><head><title>Fehler: Formular unvollst&auml;ndig</title></head>";
   print "<body background=$background>";
   print "<h2>Fehler: Formular nicht vollst&auml;ndig ausgef&uuml;llt.<br>";
   print "Bitte klicken Sie auf \"Zur&uuml;ck\".<p>";
   print "</body></html>\n";
}

elsif ( ($FORM{'Kunde_mail'} =~ tr/@//) != 1 or ($FORM{'Kunde_mail'} =~ tr/.//) < 1 ){
   ### Error message: Email address only valid when there's 1 '@' and >0 '.' ==> Please go back

   print "Content-Type: text/html\n\n";
   print "<html><head><title>Fehler: Mail-Adresse fehlerhaft</title></head>";
   print "<body background=$background>";
   print "<h2>Fehler: Mail-Adresse fehlerhaft.<br>";
   print "Bitte klicken Sie auf \"Zur&uuml;ck\".<p>";
   print "</body></html>\n";
}

else {

   # Print to File "Mail"

   open (MAIL, "|$mailprog -t") || die "Can't open $mailprog!\n";

   print MAIL "From: $FORM{'Kunde_Name'} <$FORM{'Kunde_mail'}>\n";
   print MAIL "Reply-to: $FORM{'Kunde_Name'} <$FORM{'Kunde_mail'}>\n";
   if ($FORM{'Kopie_an_Kunde'} eq 'Ja'){
      print MAIL "To:$FORM{'Kunde_Name'} <$FORM{'Kunde_mail'}>\n";
      print MAIL "Bcc: $recipient\n";
   }
   else {
      print MAIL "To: $recipient\n";
   }
   print MAIL "X-Mailer: Dimke\'s e-mail form v2.2, (C) 2001-2004, Dipl.-Ing. Markus Robert Kessler\n";
   print MAIL "Subject: $FORM{'Betreff'}\n\n";
   print MAIL "$FORM{'Nachricht'}\n";

   close (MAIL);

   # Print Confirmation of delivery

   print "Content-Type: text/html\n\n";
   print "<html><head><title>Ihre Nachricht wurde abgesandt</title></head>";
   print "<body background=$background>";
   print "<h2>Ihre Nachricht wurde abgesandt - Danke!<p>";
   print "Wir melden uns so schnell wie m&ouml;glich.</h2>";
   print "</body></html>\n";
}

exit;

